from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import MessageDialog # provid
from Globals import Persistent    # makes an object stick in the ZODB

import OFS.SimpleItem
import Acquisition
import AccessControl.Role

import re
import string
from xmlrpclib import True, False, Server

pikePort = 81

defaultCss = """
"""

defaultCustomPrefs = """
"""

defaultJavaScript = """
"""

defaultJoinNowMembersBox = """
"""

defaultNavigation = """
"""

defaultNewsDayTemplate = """
"""

defaultSignOutMembersBox = """
"""

defaultSiteStructure = """
"""

defaultTemplate = """
"""

class DocumentControl:
    """documentcontrol"""

    default = ""
    current = ""
    ownerName = ""
    ownerPassword = ""
    owned = 0

    meta_type = "Pike Compatible XML-RPC Document Control Responder"

    def __init__(self, defaultString, container, id, parent):
        """__init__"""
        self.default = defaultString
        self.current = defaultString
        self.container = container
        self.ownerName = ""
        self.ownerPassword = ""
        self.owned = 0
        self.id = id
        self.title = id
        self.parent = parent

    def checkIn(self, username, password, siteName):
        """checkIn"""
        print "manila." + self.id + ".checkIn:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", siteName
        print "---------------------"
        return True

    def get(self, username, password, siteName):
        """get"""
        print "manila." + self.id + ".get:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", siteName
        print "---------------------"
        return self.current

    def restoreDefault(self, username, password, sitename):
        """restoreDefault"""
        print "manila." + self.id + ".restoreDefault:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "---------------------"
        self.current = self.default

    def set(self, username, password, sitename, s, windowInfo):
        """set"""
        print "manila." + self.id + ".set:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "\ts           :", s
        print "\twindowInfo  :", windowInfo
        print "---------------------"
        self.current = s

class Messages:
    """messages"""

    meta_type = "Pike Compatible XML-RPC Message Responder"

    def __init__(self, id, parent):
        """   """
        self.id = id
        self.title = id
        self.parent = parent

    def addToStoriesList(self, username, password, sitename, msgNum):
        """addToStoriesList"""
        print "manila." + self.id + ".addToStoriesList:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsitename:", sitename
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return True

    def checkIn(self, username, password, siteName, msgNum):
        """checkIn"""
        print "manila." + self.id + ".checkIn:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsiteName:", siteName
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return True

    def isStory(self, username, password, sitename, msgNum):
        """isStory"""
        print "manila." + self.id + ".isStory:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsitename:", sitename
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return False

    def removeFromStoriesList(self, username, password, siteName, msgNum):
        """removeFromStoriesList"""
        print "manila." + self.id + ".removeFromStoriesList:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsitename:", siteName
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return True

    def create(self, username, password, sitename, subject, body,
               bodyType, inResponseTo, windowInfo, rendererInfo):
        """create"""
        print "manila." + self.id + ".create:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "\tsubject     :", subject
        print "\tbody        :", body
        print "\tbodyType    :", bodyType
        print "\tinResponseTo:", inResponseTo
        print "\twindowInfo  :", windowInfo
        print "\trendererInfo:", rendererInfo
        print "---------------------"
        storyInfo = {}
        return storyInfo

    def set(self, username, password, sitename, msgnum, subject, body,
            bodyType, windowInfo, rendererInfo):
        """set"""
        print "manila." + self.id + ".set:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "\tmsgnum      :", msgnum
        print "\tsubject     :", subject
        print "\tbody        :", body
        print "\tbodyType    :", bodyType
        print "\twindowInfo  :", windowInfo
        print "\trendererInfo:", rendererInfo
        print "---------------------"
        doc = self.parent.getDocument(msgnum)
        doc.manage_edit(body, subject)
        #doc.pikeWindowInfo = windowInfo
        storyInfo = self.parent.getStoryInfo(doc, None, username = username)
        return storyInfo

class PikeCompatibility(
    OFS.SimpleItem.Item,
    Persistent,
    Acquisition.Implicit,
    AccessControl.Role.RoleManager
    ):
    """The Pike Compatible XML-RPC interface"""

    meta_type = "Pike Compatible XML-RPC Interface"
    manage_options = ({'label': 'View', 'action': ''}, {'label': 'View Again', 'action': ''}) 
    #__ac_permissions__ = (('View', ('','index_html')))
    index_html = HTMLFile("pikeIndex", globals())
    manage_main = HTMLFile("pikeManage", globals())
    manage_workspace = manage_main
    _isAPikeCompatibility = 1

    def __init__(self, id):
        """__init__"""
        self.id = id
        self.title = "Pike Compatible XML-RPC Interface"
        self.manila = self
        self.docs = {}
        
        self.css = DocumentControl(
            defaultCss,
            None,
            "css",
            self)
        self.customPrefs = DocumentControl(
            defaultCustomPrefs,
            None,
            "customPrefs",
            self)
        self.javaScript = DocumentControl(
            defaultJavaScript,
            None,
            "javaScript",
            self)
        self.joinNowMembersBox = DocumentControl(
            defaultJoinNowMembersBox,
            None,
            "joinNowMembersBox",
            self)
        self.message = Messages("message", self)
        self.navigation = DocumentControl(
            defaultNavigation,
            None,
            "navigation",
            self)
        self.newsDayTemplate = DocumentControl(
            defaultNewsDayTemplate,
            None,
            "newsDayTemplate",
            self)
        self.signOutMembersBox = DocumentControl(
            defaultSignOutMembersBox,
            None,
            "signOutMembersBox",
            self)
        self.siteStructure = DocumentControl(
            defaultSiteStructure,
            None,
            "siteStructure",
            self)
        self.template = DocumentControl(
            defaultTemplate,
            None,
            "template",
            self)

    def pikeFilter(self, body):
        """pikeFilter"""
        body = re.sub("\r\n", "\n", body)
        body = re.sub("\n", "\r", body)
        return body

    def editInPike(self, doc, REQUEST):
        """   """
        self.registerDocument(doc)
        storyInfo = self.getStoryInfo(doc, REQUEST)
        siteInfo = self.getSiteInfo(doc, REQUEST)
        self.getPikeServer(REQUEST).pike.editStory(siteInfo, storyInfo)
        if REQUEST is not None:
            print "redirecting to:", self.getDocURL(doc, REQUEST)
            return REQUEST['RESPONSE'].redirect(self.getDocURL(doc, REQUEST))

    def getDocURL(self, doc, REQUEST):
        """getDocURL"""
        if hasattr(doc, 'pikeDocumentURL'):
            url = doc.pikeDocumentURL
            if len(url) < 7 or url[:-7] != "http://":
                if REQUEST is None:
                    url = doc.get_absolute_url()
                else:
                    url = REQUEST.BASE1 + url
        else:
            url = doc.absolute_url()
        return url

    def getStoryInfo(self, doc, REQUEST=None, username=None):
        """   """
        if REQUEST is None:
            member = username
        else:
            member = REQUEST.AUTHENTICATED_USER.getUserName()

        storyInfo = {}
        storyInfo['body'] = self.pikeFilter(doc.read())
        storyInfo['member'] = member
        storyInfo['msgnum'] = doc.get_absolute_url()
        storyInfo['postTime'] = ""
        storyInfo['lastUpdate'] = str(doc.bobobase_modification_time)
        storyInfo['ctReads'] = 0
        storyInfo['subject'] = doc.get_title()
        storyInfo['responses'] = []
        storyInfo['URL'] = self.getDocURL(doc, REQUEST)

        #if doc.__dict__.has_key('pikewindowInfo'):
        #    storyInfo['windowInfo'] = doc.pikeWindowInfo
        
        return storyInfo

    def getSiteInfo(self, doc, REQUEST):
        """   """
        host = REQUEST.HTTP_HOST
        i = string.find(host, ":")
        if i != -1:
            host = host[0:i]

        siteInfo = {}
        siteInfo['host'] = host
        siteInfo['port'] = REQUEST.SERVER_PORT
        siteInfo['rpcPath'] = "/" + self.absolute_url(1)
        siteInfo['siteName'] = host
        siteInfo['displaySiteName'] = host
        siteInfo['username'] = REQUEST.AUTHENTICATED_USER.getUserName()
        siteInfo['password'] = ""
        siteInfo['URL'] = self.getDocURL(doc, REQUEST)
        return siteInfo

    def getPikeServer(self, REQUEST):
        """   """
        return Server("http://" + REQUEST.REMOTE_ADDR + ":" + str(pikePort))

    def registerDocument(self, doc):
        """registerDocument"""
        self.docs[doc.get_absolute_url()] = doc

    def getDocument(self, key):
        """getDocument"""
        if not self.docs.has_key(key):
            raise AttributeError
        else:
            return self.docs[key]

manage_addPikeCompatibilityForm = HTMLFile('pikecompAdd', globals()) 

def manage_addPikeCompatibility(self, id, title='', REQUEST=None):
    """   """
    self._setObject(id, PikeCompatibility(id))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class PikeEdit:
    """MixIn that allows object to be editted by Pike"""

    def getPC(self):
        """Find a PikeCompatibility in the current folder and above"""
        while self is not None:
            if hasattr(self, 'objectValues'):
                for o in self.objectValues():
                    if hasattr(o, '_isAPikeCompatibility') and o._isAPikeCompatibility:
                        return o
            if hasattr(self, 'aq_parent'):
                self = self.aq_parent
            else:
                self = None
        raise AttributeError("No PikeCompatibility instance found!")

    def get_absolute_url(self, relative=0):
        """get_absolute_url"""
        if hasattr(self, 'document_id'):
            if self.id == self.document_id:
                return self.absolute_url(relative)
            else:
                return self.absolute_url(relative) + "/" + self.document_id
        else:
            return self.absolute_url(relative)

    def get_title(self):
        """get_title"""
        if hasattr(self, 'document_title'):
            return self.document_title
        else:
            return self.title

    def editInPike(self, REQUEST):
        """editInPike"""
        if self.may_edit(REQUEST):
            pc = self.getPC()
            pc.editInPike(self, REQUEST)

    def may_edit(self, REQUEST):
        """may_edit"""
        return REQUEST.AUTHENTICATED_USER.has_role('Manager', 'Owner')

    def edit_in_pike_button(self, REQUEST, linkText=None):
        """editInPikeButton"""
        if self.may_edit(REQUEST):
            if linkText is not None:
                return "<a href=\"" + \
                       self.absolute_url() + \
                       "/editInPike\">" + \
                       linkText + \
                       "</a>"
            else:
                return "<form action=\"" + \
                       self.absolute_url() + \
                       "/editInPike\" method=\"POST\">\n" + \
                       "<input name=\"SUBMIT\" type=\"SUBMIT\" value=\"Edit in Pike\">\n" + \
                       "</form>"
        else:
            return "<!-- user cannot edit -->"

    def edit_in_browser_button(self, REQUEST, linkText=None):
        """editInBrowserButton"""
        if self.may_edit(REQUEST):
            if linkText is not None:
                return "<a href=\"" + \
                       self.absolute_url() + \
                       "/manage_editForm\">" + \
                       linkText + \
                       "</a>"
            else:
                return "<form action=\"" + \
                       self.absolute_url() + \
                       "/manage_editForm\" method=\"POST\">\n" + \
                       "<input name=\"SUBMIT\" type=\"SUBMIT\" value=\"Edit this Page\">\n" + \
                       "</form>"
        else:
            return "<!-- user cannot edit -->"
